# Cognitive Services LUIS SDKs

> see https://aka.ms/autorest

Configuration for generating LUIS Authoring SDK.

``` yaml
tag: authoring_2_0
add-credentials: true
openapi-type: data-plane
```

The current release for the Authoring Endpoint is `authoring_2_0`.

# Releases

## Authoring 2.0
These settings apply only when `--tag=authoring_2_0` is specified on the command line.

``` yaml $(tag) == 'authoring_2_0'
input-file: stable/v2.0/LUIS-Authoring.json
```

Deprecated Pattern's Operations

``` yaml $(tag) == 'authoring_2_0'
directive:
  - reason: Deprecated
    remove-operation: Features_GetApplicationVersionPatternFeatures
  - reason: Deprecated
    remove-operation: Features_CreatePatternFeature
  - reason: Deprecated
    remove-operation: Features_GetPatternFeatureInfo
  - reason: Deprecated
    remove-operation: Features_UpdatePatternFeature
  - reason: Deprecated
    remove-operation: Features_DeletePatternFeature
```

AutoRest-Linter Suppressions

``` yaml
# Ignore autorest-linter issues that cannot be resolve without updates to the API implementation
directive:
  - suppress: DeleteMustNotHaveRequestBody
    reason: Body is used to specify entity to delete
  - suppress: DefinitionsPropertiesNamesCamelCase
    reason: Changing casing will break existing clients/consumers
```

---
# Code Generation


## Swagger to SDK

This section describes what SDK should be generated by the automatic system.
This is not used by Autorest itself.

``` yaml $(swagger-to-sdk)
swagger-to-sdk:
  - repo: azure-sdk-for-go
```

### Authoring 2.0 - CSharp Settings
These settings apply only when `--csharp` is specified on the command line.
``` yaml $(csharp)
csharp:
  sync-methods: None
  license-header: MICROSOFT_MIT_NO_VERSION
  azure-arm: false
  namespace: Microsoft.Azure.CognitiveServices.Language.LUIS.Authoring
  output-folder: $(csharp-sdks-folder)/CognitiveServices/dataPlane/Language/LUIS/Authoring/Generated
  clear-output-folder: true
```

## Go

These settings apply only when `--go` is specified on the command line.

``` yaml $(go)
go:
  license-header: MICROSOFT_APACHE_NO_VERSION
  namespace: authoring
  clear-output-folder: true
```

### Go multi-api

``` yaml $(go) && $(multiapi)
batch:
  - tag: authoring_2_0
```

### Tag: authoring_2_0 and go

These settings apply only when `--tag=authoring_2_0 --go` is specified on the command line.
Please also specify `--go-sdk-folder=<path to the root directory of your azure-sdk-for-go clone>`.

``` yaml $(tag) == 'authoring_2_0' && $(go)
output-folder: $(go-sdk-folder)/services/cognitiveservices/v2.0/luis/$(namespace)
```


## Java

These settings apply only when `--java` is specified on the command line.
Please also specify `--azure-libraries-for-java-folder=<path to the root directory of your azure-libraries-for-java clone>`.

``` yaml $(java)
java:
  azure-arm: true
  namespace: com.microsoft.azure.cognitiveservices.language.luis.authoring
  license-header: MICROSOFT_MIT_NO_CODEGEN
  payload-flattening-threshold: 1
  output-folder: $(azure-libraries-for-java-folder)/azure-cognitiveservices/language/luis/authoring
  with-optional-parameters: true
  with-single-async-method: true
```
